/*
  Name: SPI_ASM.h
  Copyright: jaja
  Author: Kai Scheddin
  Date: 02.04.07 16:19
  Description: SPI asm header
*/
#ifndef SPI_H
#define SPI_H
#include "io/spi_config.h"

#ifdef NEED_SPI_STANDART
extern "C" void spi__standart_init(void);
extern "C" void spi_sendbyte(unsigned char c);
/*blockating  routine, waits till SPIF is clear, 
sends and waits till SPIF is clear*/
extern "C" unsigned char spi_rcvbyte(void);
#endif

#ifdef NEED_SPI_SHORTYS
extern "C" void spi_clock_set(unsigned char c); 
/*c=2,4,8,16,32,64,128,.. different values will be ignored, 64 will be spi2x=on*/
extern "C" void spi_set_master(void);
extern "C" void spi_set_slave(void);
extern "C" void spi_set_endian(unsigned char c); 
/*0x00 for LSB, 0x01 for MSB, rest will be ignored*/
#endif

#ifdef NEED_SPI_DIRECTS
extern "C" void spi_set_spcr(unsigned char c);
/*out SPCR,c*/
extern "C" void spi_set_spsr(unsigned char c);
/*out SPSR,c*/
extern "C" void spi_set_spdr(unsigned char c);
/*not protected write (send) mode*/

extern "C" unsigned char spi_get_spcr(void);
extern "C" unsigned char spi_get_spsr(void);
extern "C" unsigned char spi_get_spdr(void);
#endif


#ifdef NEED_SPI_EXTENDED
/*
Cable has to be preselected by User, its not implemented for full flexibilty
*/
extern "C" void spi_sendstring(unsigned char *c);
extern "C" void spi_rcvstring(unsigned char *allocstring, int length);
extern "C" void spi_rcvstring2(char dummy,unsigned char *allocstring,int length);
extern "C" void spi_rcvstring3(char master_command,char dummy,unsigned char *allocstring,int length);
#endif


#endif
