/*
  Name: Usart_asm.asm, 
  Copyright: Kai (ZeuSOsC) Scheddin, 2007, 
  Author: Kai Scheddin        
  Date: 30.03.07 09:54
  Description: part of rem-controll v0.1

HINWEIS:
hier werden direkt auf register zugegriffen, und
es wird verzichtet sie im stack zu sichern,
bei recombilate und derer gleichen sollte dies bercksichtigt werden.
*/

#include "usart_config.h"





#ifdef NEED_U_STANDART

/*;19200,8,n,1 by 16Mhz*/
.global u_standart_init
.func u_standart_init
u_standart_init:
ldi r16,51
out UBRRL,r16
ldi r16,0x00
out UBRRH,r16
ldi r16, (1<<URSEL)|(3<<UCSZ0)	/*Frame-Format: 8 Bit*/
out UCSRC,r16
/*sbr UCSRB, RXCIE        ;Interrupt bei Empfang*/
in r16,UCSRB
sbr r16,TXEN
sbr r16,RXEN
out UCSRB,r16
ret
.endfunc
#endif

#ifdef NEED_U_SHORTYS

.global u_set_baud
.func u_set_baud
u_set_baud:
out UBRRL,r24
out UBRRH,r25


sbi UCSRB,RXEN         /*Empfang aktivieren*/
sbi UCSRB,TXEN          /*Senden aktivieren*/  

ret
.endfunc

.global u_set_rxd
.func u_set_rxd
u_set_rxd:
sbi UCSRB,RXEN         /*Empfang aktivieren*/
.endfunc

.global u_set_txd
.func u_set_txd
u_set_txd:
sbi UCSRB,TXEN          /*Senden aktivieren  */
.endfunc

.global u_set_int
.func u_set_int
u_set_int:
sbi UCSRB,RXCIE        /*Interrupt bei Empfang*/
.endfunc

.global u_uset_rxd
.func u_uset_rxd
u_uset_rxd:
cbi UCSRB, RXEN         /*Empfang deaktivieren*/
.endfunc

.global u_uset_txd
.func u_uset_txd
u_uset_txd:
cbi UCSRB,TXEN         /*Senden deaktivieren*/
.endfunc

.global u_uset_int
.func u_uset_int
u_uset_int:
cbi UCSRB,RXCIE        /*Empfang Interrupt deaktivieren*/
.endfunc
#endif

#ifdef NEED_U_EXTENDED
.global u_init
.func u_init
u_init:
out UBRRL,r22         /*umrechnung manuell oder per c postcompilat*/
out UBRRH,r24
/*hier ohne sprungtabelle,.. muss ja net sein bei 4 varianten*/
mov r2,r16
clr r16
clr r17
in r16,UCSRC
in r17,UCSRB

sbr r16,URSEL

/*vielleicht mach ich noch ne sptere abfrage bzgl. a/synchronitt*/
/*setze auf asynchronitt*/
sbr r16,UMSEL /*UMSEL*/

/*paritt*/
cpi r18,'N'/*no*/
breq 1f
cpi r18,'n'
breq 1f
cpi r18,'O'/*odd*/
breq 2f
cpi r18,'o'
breq 2f
cpi r18,'E'/*even*/
breq 3f
cpi r18,'e'
breq 3f

1:
cbr r16,4 /*UPM0 --US(A)RT Parity Mode Bit 0*/
cbr r16,5 /*UPM1 -- " 1"*/
rjmp 4f

2:
cbr r16,4
sbr r16,5
rjmp 4f
	
3:
sbr r16,4
sbr r16,5

4:


/*stobbits*/
sbrs r2,2   
cbr r16,3
sbr r16,3

/*databits*/
cpi r20,5
breq 1f
cpi r20,6
breq 2f
cpi r20,7
breq 3f
cpi r20,8
breq 4f
cpi r20,9
breq 5f
brne 4f

1:
cbr r17,2
cbr r16,1
cbr r16,2
rjmp 6f

2:
cbr r17,2
sbr r16,1
cbr r16,2
rjmp 6f

3:
cbr r17,2
cbr r16,1
sbr r16,2
rjmp 6f

4:
cbr r17,2
sbr r16,1
sbr r16,2
rjmp 6f

5:
sbr r17,2
sbr r16,1
sbr r16,2

6:
out UCSRC,r16

sbr r17,RXEN        /*Empfang aktivieren*/
sbr r17,TXEN         /*Senden aktivieren*/  

out UCSRB,r17

ret
.endfunc
#endif

#ifdef NEED_U_STANDART

.global u_sendbyte
.func u_sendbyte
u_sendbyte:
7:
/*  ; warten bis das UART bereit ist*/
sbis UCSRA,7
rjmp 7b
out UDR,r24

ret
.endfunc
#endif

#ifdef NEED_U_NON_BLOCK

.global u_non_blocking_sendbyte
.func u_non_blocking_sendbyte
u_non_blocking_sendbyte:
out UDR,r24
ret
.endfunc
#endif

#ifdef NEED_U_STANDART

.global u_rcvbyte
.func u_rcvbyte
u_rcvbyte:
clr r24
8:
in r24,UDR
cpi r24,0
breq 8b
ret
.endfunc
#endif

#ifdef NEED_U_NON_BLOCK

.global u_non_blocking_rcv
.func u_non_blocking_rcv
u_non_blocking_rcv:
in r24,UDR
ret
.endfunc
#endif

#ifdef INC_U_INT_RXC

.global USART_RXC_vect
.func USART_RXC_vect
USART_RXC_vect:
mov r16,r24
reti
.endfunc
#endif

#ifdef INC_U_INT_UDRE

.global USART_UDRE_vect
.func USART_UDRE_vect
USART_UDRE_vect:
mov r23,r16
reti
.endfunc
#endif

#ifdef INC_U_INT_TXC

.global USART_TXC_vect
.func USART_TXC_vect
USART_TXC_vect:
mov r22,r13
reti
.endfunc
#endif




#ifdef NEED_U_EXTENDED
.global u_sendstring
.func u_sendstring
u_sendstring:
/*high nibble r25, low nibble r24*/
push r26
push r27
mov r27,r25
mov r26,r24

12:
ld r24,X+
cpi r24,0
breq 14f
13:
sbis UCSRA,7
rjmp 13b
out UDR,r24
rjmp 12b
14:

pop r27
pop r26
ret             
.endfunc
#endif


#ifdef NEED_U_EXTENDED
.global u_rcvstring
.func u_rcvstring
u_rcvstring:
/*disable RXCIE, if disabled set flag to r17*/
in r16,UCSRB
sbrc r16,7
rjmp 14f
ldi r17,0x01
cbr r16,7
out UCSRB,r16
14:
/*save x,z counter*/
push r26
push r27
push r30
push r31
clr r31
clr r30
mov r27,r25
mov r26,r24
/*loop, inc counter, wait untill data rcv'd rejump*/
15:
adiw r30,1
151:
sbis UCSRA,RXC
rjmp 151b
in r16,UDR
st X+,r16
cp r30,r22
cpc r31,r23
breq 16f
rjmp 15b


16:
sbrs r17,0
rjmp 17f
sbr r16,7
out UCSRB,r16
17:
pop r31
pop r30
pop r27
pop r26

ret
.endfunc
#endif


.end
