
#include <inttypes.h>
#include "usart_config.h"

#ifndef USART_H
#define USART_H

#ifdef NEED_U_STANDART
extern "C" void u_standart_init(void);
extern "C" void u_sendbyte(unsigned char send);
extern "C" unsigned char u_rcvbyte(void);
#endif

#ifdef NEED_U_SHORTYS
extern "C" void u_set_baud(unsigned char ubrrvalhi,unsigned char ubrrvallo);
extern "C" void u_set_rxd(void);
extern "C" void u_set_txd(void);
extern "C" void u_set_int(void);
extern "C" void u_uset_rxd(void);
extern "C" void u_uset_txd(void);
extern "C" void u_uset_int(void);
#endif

#ifdef NEED_U_EXTENDED
extern "C" void u_init(uint8_t baudhi,uint8_t baudlo,uint8_t databits,char parity,uint8_t stopbits);
extern "C" void u_sendstring(unsigned char *c);
extern "C" void u_rcvstring(unsigned char* c, int length);
/* waits until length is reached, rxcie should be disabled */
#endif





#ifdef NEED_U_NON_BLOCK 
extern "C" bool u_non_blocking_sendbyte(unsigned char send); 
extern "C" unsigned char u_non_blocking_rcv(void);
#endif

#endif
