#ifndef USART_CONFIG_H
#define USART_CONFIG_H

/* ********************************USART ***********************************/

#define NEED_U_STANDART

/**********INCLUDING USART INTERRUPT ROUTINES *********************/

#ifdef USART_RXC_vect
#undef USART_RXC-vect
#endif
#ifdef USART_UDRE_vect
#undef USART_UDRE_vect
#endif
#ifdef USART_TXC_vect
#undef USART_TXC_vect
#endif

#define USART_RXC_vect  __vector_13
#define USART_UDRE_vect	__vector_14
#define USART_TXC_vect	__vector_15


#define INC_U_INT_RXC
#define INC_U_INT_TXC
#define INC_U_INT_UDRE

/********************IF THERE IS A NEED FOR SPECIAL FUNCTIONS*****/
#define NEED_U_NON_BLOCK

#define NEED_U_EXTENDED
#define NEED_U_SHORTYS



#define UCSRA 0x0b
#define UCSRB 0x0a
#define UCSRC 0x20

#define UCSZ0 1
#define UCSZ1 2
#define UCSZ2 2
#define TXEN 3	
#define RXEN 4	

#define UDRIE 5	
#define TXCIE 6	
#define RXCIE 7	

#define TXC 6	
#define RXC 7	

#define UMSEL 6	
#define URSEL 7	


#define UBRRH 0x20
#define UBRRL 0x09
#define UDR0 0	
#define UDR1 1	
#define UDR2 2	
#define UDR3 3	
#define UDR4 4	
#define UDR5 5	
#define UDR6 6	
#define UDR7 7	
#define UDRE 5



#define UDR 0x0c




/*****ADDITIONAL WARNINGS*****************************/
#ifndef NEED_U_STANDART
#warning "USART STANDART functions not added."
#endif
#ifndef INC_U_INT_RXC
#warning "USART RXC Interrupt function not included."
#endif
#ifndef INC_U_INT_TXC
#warning "USART TXC Interrupt function not included."
#endif
#ifndef INC_U_INT_UDRE
#warning "USART UDRE Interrupt function not included."
#endif
#ifndef NEED_U_NON_BLOCK
#warning "USART NON Blocking recive and sending functions not added."
#endif
#ifndef NEED_U_EXTENDED
#warning "USART EXTENDED functions not added."
#endif
#ifndef NEED_U_SHORTYS
#warning "USART SHORTY functions not added."
#endif


#endif
